keystate_import_cmd.c File Reference
`#include "config.h"`
`#include <getopt.h>`
`#include "cmdhandler.h"`
`#include "daemon/enforcercommands.h"`
`#include "daemon/engine.h"`
`#include "file.h"`
`#include "log.h"`
`#include "str.h"`
`#include "clientpipe.h"`
`#include "longgetopt.h"`
`#include "duration.h"`
`#include "libhsm.h"`
`#include "libhsmdns.h"`
`#include "db/key_data.h"`
`#include "db/db_error.h"`
`#include "keystate/keystate_import_cmd.h"`
`#include "keystate/keystate_list_cmd.h"`

Go to the source code of this file.

## Functions

int | perform_hsmkey_import (int sockfd, db_connection_t *dbconn, const char *ckaid, const char *rep, const char *zonename, int bits, int alg, int keytype, unsigned int time)
int | perform_keydata_import (int sockfd, db_connection_t *dbconn, const char *ckaid, const char *rep, const char *zonename, int alg, int keystate, int keytype, unsigned int time, int setmin, db_value_t *hsmkey_id)
int | perform_keystate_import (int sockfd, db_connection_t *dbconn, const char *ckaid, const char *rep, const char *zonename, int keystate, int keytype, unsigned int time, db_value_t *hsmkeyid)

## Variables

const int | ksk_mapping [5][4] = {{0,0,0,4},{0,1,1,4},{1,2,2,4},{1,2,2,4},{3,2,2,4}}
const int | zsk_mapping [5][4] = {{4,0,4,0},{4,1,4,0},{4,2,4,1},{4,2,4,2},{4,2,4,3}}
const int | ds_at_parent [5] = {0,0,1,3,5}
struct cmd_func_block | key_import_funcblock

## Function Documentation

## perform_hsmkey_import()

int perform_hsmkey_import | ( | int | sockfd,
|  | db_connection_t * | dbconn,
|  | const char * | ckaid,
|  | const char * | rep,
|  | const char * | zonename,
|  | int | bits,
|  | int | alg,
|  | int | keytype,
|  | unsigned int | time
| ) |  |

Definition at line 63 of file keystate_import_cmd.c.

References hsm_key_create(), hsm_key_free(), HSM_KEY_KEY_TYPE_RSA, hsm_key_new(), hsm_key_new_get_by_locator(), hsm_key_set_algorithm(), hsm_key_set_bits(), hsm_key_set_inception(), hsm_key_set_key_type(), hsm_key_set_locator(), hsm_key_set_policy_id(), hsm_key_set_repository(), hsm_key_set_role(), hsm_key_set_state(), HSM_KEY_STATE_PRIVATE, zone_db_free(), zone_db_new_get_by_name(), and zone_db_policy_id().

## perform_keydata_import()

int perform_keydata_import | ( | int | sockfd,
|  | db_connection_t * | dbconn,
|  | const char * | ckaid,
|  | const char * | rep,
|  | const char * | zonename,
|  | int | alg,
|  | int | keystate,
|  | int | keytype,
|  | unsigned int | time,
|  | int | setmin,
|  | db_value_t * | hsmkey_id
| ) |  |

Definition at line 134 of file keystate_import_cmd.c.

References db_value_copy(), ds_at_parent, hsm_key_free(), hsm_key_id(), hsm_key_new_get_by_locator(), key_data_create(), key_data_free(), key_data_new(), KEY_DATA_ROLE_SEP, key_data_set_active_ksk(), key_data_set_active_zsk(), key_data_set_algorithm(), key_data_set_ds_at_parent(), key_data_set_hsm_key_id(), key_data_set_inception(), key_data_set_introducing(), key_data_set_keytag(), key_data_set_minimize(), key_data_set_publish(), key_data_set_role(), key_data_set_zone_id(), zone_db_free(), zone_db_id(), and zone_db_new_get_by_name().

## perform_keystate_import()

int perform_keystate_import | ( | int | sockfd,
|  | db_connection_t * | dbconn,
|  | const char * | ckaid,
|  | const char * | rep,
|  | const char * | zonename,
|  | int | keystate,
|  | int | keytype,
|  | unsigned int | time,
|  | db_value_t * | hsmkeyid
| ) |  |

Definition at line 213 of file keystate_import_cmd.c.

References key_data_free(), key_data_id(), key_data_minimize(), key_data_new_get_by_hsm_key_id(), key_state_create(), key_state_free(), key_state_new(), key_state_set_key_data_id(), key_state_set_last_change(), key_state_set_minimize(), key_state_set_state(), key_state_set_ttl(), key_state_set_type(), KEY_STATE_TYPE_DNSKEY, KEY_STATE_TYPE_DS, KEY_STATE_TYPE_RRSIG, KEY_STATE_TYPE_RRSIGDNSKEY, ksk_mapping, policy_denial_ttl(), POLICY_DENIAL_TYPE_NSEC3, policy_free(), policy_get_by_id(), policy_keys_ttl(), policy_new(), policy_parent_ds_ttl(), policy_signatures_max_zone_ttl(), policy_zone_soa_minimum(), policy_zone_soa_ttl(), zone_db_free(), zone_db_new_get_by_name(), zone_db_policy_id(), and zsk_mapping.

## Variable Documentation

## ds_at_parent

const int ds_at_parent[5] = {0,0,1,3,5}

Definition at line 55 of file keystate_import_cmd.c.

Referenced by key_data_ds_at_parent_clause(), key_data_from_result(), key_data_set_ds_at_parent(), and perform_keydata_import().

## key_import_funcblock

struct cmd_func_block key_import_funcblock

Initial value:
= {
"key import", &usage, &help, NULL, NULL, &run, NULL
}

Definition at line 571 of file keystate_import_cmd.c.

## ksk_mapping

const int ksk_mapping[5][4] = {{0,0,0,4},{0,1,1,4},{1,2,2,4},{1,2,2,4},{3,2,2,4}}

Definition at line 53 of file keystate_import_cmd.c.

Referenced by perform_keystate_import().

## zsk_mapping

const int zsk_mapping[5][4] = {{4,0,4,0},{4,1,4,0},{4,2,4,1},{4,2,4,2},{4,2,4,3}}

Definition at line 54 of file keystate_import_cmd.c.

Referenced by perform_keystate_import().